/****************************************************************************************/
/*** modification story                                                           *******/
/****************************************************************************************/
//	driver.c
/****************************************************************************************/
//********* include ***********
#include "MyTypes.h"
#include "MyGlobals.h"

#include <string.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <asm/io.h>


//***************************************************************************//
//  Parallel Port access
// Base 0x378 : Data (out)
//	0x379 : Status (in)
//	0x37A : Control (out)


//***************************************************************************//
// Internal Function :
// OpenIOPort:	Open Driver to access hardware
// returns : COK: normal execution
//			OPEN_DRIVER_READ_ERR
//*****************************************************************************//
int OpenParPort(void)
{
	return COK;
}

/*****************************************************************************
// Internal Function : 
// OpenIOPort:	Write byte to parallele port
// returns : COK: normal execution
//			WRITE_ERROR		: close error: see getlasterror
//*****************************************************************************/
int WriteParPort(unsigned char Data2Write)
{
	//int Result;
	if (ioperm(ParallelPortBaseAddress,1,1))
			// ask for permissions to access the parallel port
			// YOU MUST BE ROOT TO ASK FOR THIS SORT OF PERMISSION, so
			//     don't forget to 'su' yourself ;-)
			// we don't want to interfere with other code
			// usage of ioperm: BASEPORT ... base address we want to use
			//		3 ... the next 3 bytes
			//		1 ... we want the permission
	{
		printf("Hmm...rights error, no permission for CGI to complete action successfuly");
		return (CNOK);
	}
	else
	{
		outb(Data2Write, ParallelPortBaseAddress);
		return (COK);
	}
}

/*****************************************************************************
// Internal Function :
// OpenIOPort:	Open Driver to access hardware under Windows NT
// returns : COK: normal execution
//			 CNOK : READ error: see getlasterror
//*****************************************************************************/
unsigned char ReadParPort(void)
{
	unsigned char ReadData;
	if (ioperm(ParallelPortBaseAddress,3,1))
			// ask for permissions to access the parallel port
			// YOU MUST BE ROOT TO ASK FOR THIS SORT OF PERMISSION, so
			//     don't forget to 'su' yourself ;-)
			// we don't want to interfere with other code
			// usage of ioperm: BASEPORT ... base address we want to use
			//		3 ... the next 3 bytes
			//		1 ... we want the permission
	{
		printf("Hmm...some errors, no read permission for CGI to complete action successfuly");
		return (CNOK);
	}
	else
	{
		ReadData=inb(ParallelPortBaseAddress+1);
        	return (ReadData);
	}
}

/*****************************************************************************
// Internal Function : 
// OpenIOPort:	Open Driver to access hardware under Windows NT
// returns : COK: normal execution
//			CLOSE_DRIVER_ERR		: close error: see getlasterror
//*****************************************************************************/
int CloseParPort(void)
{
	return COK;

}
